Tizen 2.0 Release
[external/tizen-coreutils.git] / tests / misc / close-stdout
1 #!/bin/sh
2 # Ensure that several programs work fine, even with stdout initially closed.
3 # This is effectively a test of closeout.c's close_stdout function.
4
5 # Copyright (C) 2004, 2006 Free Software Foundation, Inc.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2 of the License, or
10 # (at your option) any later version.
11
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 # 02110-1301, USA.
21
22 if test "$VERBOSE" = yes; then
23   set -x
24   rm --version
25 fi
26
27 pwd=`pwd`
28 t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
29 trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
30 trap '(exit $?); exit $?' 1 2 13 15
31
32 framework_failure=0
33 mkdir -p $tmp || framework_failure=1
34 cd $tmp || framework_failure=1
35
36 if test $framework_failure = 1; then
37   echo "$0: failure in testing framework" 1>&2
38   (exit 1); exit 1
39 fi
40
41 PATH="$pwd/../..:$PATH"
42 export PATH
43
44 fail=0
45
46 # Ensure these exit successfully, even though stdout is closed,
47 # because they generate no output.
48 touch a
49 cp a b >&- || fail=1
50 test -f b || fail=1
51 chmod o-w . >&- || fail=1
52 ln a c >&- || fail=1
53 rm c >&- || fail=1
54 mkdir d >&- || fail=1
55 mv d e >&- || fail=1
56 rmdir e >&- || fail=1
57 touch e >&- || fail=1
58 sleep 0 >&- || fail=1
59 "$pwd/../../src/true" >&- || fail=1
60 "$pwd/../../src/printf" '' >&- || fail=1
61
62 # If >&- works, ensure these fail, because stdout is closed and they
63 # *do* generate output.  >&- apparently does not work in HP-UX 11.23.
64 # This test is ineffective unless /dev/stdout also works.
65 if "$pwd/../../src/test" -w /dev/stdout >/dev/null &&
66    "$pwd/../../src/test" ! -w /dev/stdout >&-; then
67   "$pwd/../../src/printf" 'foo' >&- 2>/dev/null && fail=1
68   cp --verbose a b >&- 2>/dev/null && fail=1
69 fi
70
71 # Likewise for /dev/full, if /dev/full works.
72 if test -w /dev/full && test -c /dev/full; then
73   "$pwd/../../src/printf" 'foo' >/dev/full 2>/dev/null && fail=1
74   cp --verbose a b >/dev/full 2>/dev/null && fail=1
75 fi
76
77 (exit $fail); exit $fail